library flame_tapable_component;

import 'package:flame/components/component.dart';
import 'package:flame/components/mixins/tapable.dart';
import 'package:flutter/gestures.dart';

/// TapableComponent based on Flame's [PositionComponent] which uses the 
/// [Tapable] mixin and globalPosition rather than localPosition
abstract class TapableComponent extends PositionComponent with Tapable {
  @override
  void handleTapDown(TapDownDetails details) {
    if (checkTapOverlap(details.localPosition)) {
      onTapDown(details);
    }
    tapableChildren().forEach((c) => c.handleTapDown(details));
  }

  @override
  void handleTapUp(TapUpDetails details) {
    if (checkTapOverlap(details.localPosition)) {
      onTapUp(details);
    }
    tapableChildren().forEach((c) => c.handleTapUp(details));
  }
}
